library Remote;

uses
  SysUtils, Classes, Dialogs, Windows, ActiveX, extctrls;

type TKeyCode = ^byte;
  TKeyTimer = class(TTimer)
    procedure DoOnTimer(Sender: TObject);
  end;
  tcallbackprc = procedure(vCode: Integer);
  pcallbackprc = ^tcallbackprc;

var TsctvwdmLib: thandle;
  GetTVParam: function(value: integer): integer; cdecl;
  SetTVParam: function(value1: integer; value2: integer): integer; cdecl;
  SaveExit: Pointer;
  aTimer: TKeyTimer;
  CallBackProc: tcallbackprc;

procedure LocalExitProc;
begin
  aTimer.Enabled := false;
  aTimer.Free;
  GetTVParam := nil;
  SetTVParam := nil;
  if TsctvwdmLib <> 0 then FreeLibrary(TsctvwdmLib);
  TsctvwdmLib := 0;
  CoUninitialize;
  ExitProc := SaveExit;
end;

procedure SetCallbackProc(cbp: pcallbackprc);
begin
   @CallBackProc := cbp;
end;

exports SetCallbackProc;

{ TKeyTimer }

procedure TKeyTimer.DoOnTimer(Sender: TObject);
var key: integer;
begin
  key := GetTVParam($11);
  if key <> 0 then CallBackProc(key);
end;

//

begin
  TsctvwdmLib := loadlibrary('Tsctvwdm.dll');
  if TsctvwdmLib <> 0 then
  begin
    GetTVParam := GetProcAddress(TsctvwdmLib, 'GetTVParam');
    SetTVParam := GetProcAddress(TsctvwdmLib, 'SetTVParam');
  end else
  begin
    ShowMessage('  Tsctvwdm.dll');
    Exit;
  end;
  CoInitialize(nil);
  SetTVParam($20, $0);

  aTimer := TKeyTimer.Create(nil);
  aTimer.OnTimer := aTimer.DoOnTimer;
  aTimer.Interval := 50;
  aTimer.Enabled := true;

  SaveExit := ExitProc;
  ExitProc := @LocalExitProc;
end.

